PROGRAM NETDIFF;

USES CRT, DOS;

CONST maxflags = 30;
      spc = '                                                     ';

TYPE NodeAdressType = RECORD
                        zone: INTEGER;   (* Zone *)
                        net:  INTEGER;   (* zugehoeriges Netz *)
                        adr:  INTEGER;   (* zugehoerige Adresse *)
                        reg:  INTEGER;   (* zugehoerige Region *)
                        ges:  STRING;    (* Nodeadresse x:yyyy/zzzz *)
                        nlc:  STRING;    (* zugehoeriger NL-Verantw. *)
                      END;

TYPE FlagSetType = RECORD
                     num: INTEGER;
                     f:   ARRAY [1..maxflags] OF STRING[7];
                   END;

TYPE NLEntryType = RECORD
                     fu:  STRING; (* Funktion *)
                     na:  NodeAdressType;
                     bn:  STRING; (* BBS-Name *)
                     ci:  STRING; (* Ort *)
                     sn:  STRING; (* Sysop-Name *)
                     tn:  STRING; (* Telefon-Nr. *)
                     ge:  STRING; (* Geschwindigkeit *)
                     fl:  STRING; (* Flags *)
                     fs:  FlagSetType;
                     nn:  BOOLEAN; (* normal Node *)
                   END;

VAR f,g,h:      text;
    edatei1:    STRING;
    edatei2:    STRING;
    eingabe:    STRING;
    adatei:     STRING;
    verg:       STRING;
    first:      BOOLEAN;
    code:       INTEGER;
    parms:      WORD;
    flag:       STRING;
    flag1:      STRING;
    oldname:    STRING;
    nlentry:    NLEntryType;
    aktna:      NodeAdressType;
    nadds:      ARRAY [1..550] OF STRING[15];
    nstas:      ARRAY [1..550] OF STRING[10];
    nnlcs:      ARRAY [1..550] OF STRING[12];
    nsnam:      ARRAY [1..550] OF STRING[30];
    nfous:      ARRAY [1..550] OF BOOLEAN;
    index,t:    INTEGER;
    stat:       INTEGER;

PROCEDURE checkIO;
   BEGIN
      code:=IOResult;
      IF code<>0 THEN
         BEGIN
            WriteLn('I/O-Fehler ',code,' occured -> program end.');
            Halt(code);
         END;
   END;

FUNCTION bildeadr(a,b,c: INTEGER):STRING;
   VAR buf, buf2: STRING;
   BEGIN
      STR(a,buf);
      buf2:=buf+':';
      STR(b,buf);
      buf2:=buf2+buf+'/';
      STR(c,buf);
      buf2:=buf2+buf;
      bildeadr:=buf2;
   END;

FUNCTION upper(a:STRING):STRING;
   VAR x: INTEGER;
   BEGIN
     FOR x:=1 TO Length(a) DO
        a[x]:=upcase(a[x]);
     upper:=a;
   END;

FUNCTION ohnestrich(a:STRING):STRING;
   VAR x: INTEGER;
   BEGIN
     FOR x:=1 TO Length(a) DO
        IF a[x]='_' THEN a[x]:=' ';
     ohnestrich:=a;
   END;

PROCEDURE make_nlentry(e1:STRING; VAR e2: NodeAdressType; VAR a:NLEntryType);
   VAR b:      STRING;
       kurz:   INTEGER;
       x:      INTEGER;
       ziffer: INTEGER;
   BEGIN
      a.fu:='NN';
      kurz:=1;
      a.nn:=TRUE;
      e2.zone:=2;  (* default, wenn keine Zone vorhanden *)

      (* Funktion *)
      IF upper(copy(e1,1,5))='ZONE,' THEN
         BEGIN
            a.fu:='ZC';
            kurz:=5;
            a.nn:=FALSE;
         END;
      IF upper(copy(e1,1,7))='REGION,' THEN
         BEGIN
            a.fu:='RC';
            kurz:=7;
            a.nn:=FALSE;
         END;
      IF upper(copy(e1,1,5))='HOST,' THEN
         BEGIN
            a.fu:='HOST';
            kurz:=5;
            a.nn:=FALSE;
         END;
      IF upper(copy(e1,1,4))='HUB,' THEN
         BEGIN
            a.fu:='HUB';
            kurz:=4;
         END;
      IF upper(copy(e1,1,4))='PVT,' THEN
         BEGIN
            a.fu:='PVT';
            kurz:=4;
         END;
      IF upper(copy(e1,1,5))='HOLD,' THEN
         BEGIN
            a.fu:='HOLD';
            kurz:=5;
         END;
      IF upper(copy(e1,1,5))='DOWN,' THEN
         BEGIN
            a.fu:='DOWN';
            kurz:=5;
         END;
      e1:=copy(e1,kurz+1,length(e1)-kurz);

      (* Nodenummer *)
      kurz:=1;
      WHILE e1[kurz]<>',' DO
         INC(kurz);
      VAL(copy(e1,1,kurz-1),ziffer,x);
      e1:=copy(e1,kurz+1,length(e1)-kurz);
      IF a.fu='ZC' THEN
         BEGIN
            e2.zone:=ziffer;
            e2.reg:=0;
            e2.net:=ziffer;
            e2.adr:=0;
            e2.nlc:=bildeadr(e2.zone,e2.net,e2.adr);
         END;
      IF a.fu='RC' THEN
         BEGIN
            e2.reg:=ziffer;
            e2.net:=ziffer;
            e2.adr:=0;
            e2.nlc:=bildeadr(e2.zone,e2.net,e2.adr);
         END;
      IF a.fu='HOST' THEN
         BEGIN
            e2.net:=ziffer;
            e2.adr:=0;
            e2.nlc:=bildeadr(e2.zone,e2.net,e2.adr);
         END;
      IF a.nn THEN
         BEGIN
            e2.adr:=ziffer;
         END;
      IF a.fu='HUB' THEN
         BEGIN
            e2.nlc:=bildeadr(e2.zone,e2.net,e2.adr);
         END;
      e2.ges:=bildeadr(e2.zone,e2.net,e2.adr);

      (* Funktion *)
      IF e2.net=e2.zone THEN
         IF (e2.reg=0) AND (e2.adr<>0) THEN
            BEGIN
               a.fu:='Z-I';
               e2.nlc:=bildeadr(e2.zone,e2.net,0);
            END;

      IF e2.net=e2.reg THEN
         IF e2.adr<>0 THEN
            BEGIN
               a.fu:='R-I';
               e2.nlc:=bildeadr(e2.zone,e2.reg,0);
            END;

      a.na:=e2;

      (* BBS-Name *)
      kurz:=1;
      WHILE e1[kurz]<>',' DO
         INC(kurz);
      a.bn:=ohnestrich(copy(e1,1,kurz-1));
      e1:=copy(e1,kurz+1,length(e1)-kurz);

      (* City *)
      kurz:=1;
      WHILE e1[kurz]<>',' DO
         INC(kurz);
      a.ci:=ohnestrich(copy(e1,1,kurz-1));
      e1:=copy(e1,kurz+1,length(e1)-kurz);

      (* Sysop-Name *)
      kurz:=1;
      WHILE e1[kurz]<>',' DO
         INC(kurz);
      a.sn:=ohnestrich(copy(e1,1,kurz-1));
      e1:=copy(e1,kurz+1,length(e1)-kurz);

      (* Telefon-Nr *)
      kurz:=1;
      WHILE e1[kurz]<>',' DO
         INC(kurz);
      a.tn:=copy(e1,1,kurz-1);
      e1:=copy(e1,kurz+1,length(e1)-kurz);

      (* Geschwindigkeit *)
      kurz:=1;
      WHILE e1[kurz]<>',' DO
         INC(kurz);
      a.ge:=copy(e1,1,kurz-1);
      e1:=copy(e1,kurz+1,length(e1)-kurz);

      (* Flags *)
      a.fl:=e1;

   END;

FUNCTION suchen(a,b,c:string;VAR y,x:STRING):INTEGER;
   (* suchen=1 -> nicht gefunden in alter Liste *)
   (* suchen=2 ->       gefunden in alter Liste ohne Statusaenderung *)
   (* suchen=3 ->       gefunden in alter Liste  mit Statusaenderung *)
   (* suchen=4 ->       gefunden in alter Liste (Namensaenderung)    *)
   VAR i: INTEGER;
   BEGIN
      i:=0;
      REPEAT
         INC(i);
      UNTIL (nadds[i]=a) OR (i>=index);
      suchen:=1;
      x:=nstas[i];
      IF nadds[i]=a THEN
         BEGIN
            suchen:=2;
            nfous[i]:=FALSE;
            IF nstas[i]<>b THEN
               suchen:=3
            ELSE
               IF nsnam[i]<>c THEN
                  BEGIN
                     (* Sysopname hat gewechselt *)
                     y:=nsnam[i];
                     suchen:=4
                  END;
         END;
   END;

BEGIN

    parms:=Paramcount;

    WriteLn;
    writeln('NETDIFF V1.1 by Ralf Mahler');
    writeln('===========================');
    writeln(' ');

    IF parms<>3 THEN
       BEGIN
          WriteLn('Aufruf:   NETDIFF NetWork-File(old) NetWork-File(new) Output');
          WriteLn('Beispiel: NETDIFF NET2433.159       NET2433.166       NET2433.DIF');
          Halt(999);
       END
    ELSE
       BEGIN
          edatei1:=paramstr(1);
          edatei2:=paramstr(2);
          adatei:=paramstr(3);
       END;

    index:=1;

    {$I-}

    assign(f,edatei1);
    reset(f);
    CheckIO;

    WHILE NOT eof(f) DO
       BEGIN
          readln(f,eingabe);
          checkIO;
          IF eingabe[1]<>';' THEN
             BEGIN
                make_nlentry(eingabe,aktna,nlentry);
                nadds[index]:=nlentry.na.ges;
                nnlcs[index]:=nlentry.na.nlc;
                nstas[index]:=nlentry.fu;
                nsnam[index]:=nlentry.sn;
                nfous[index]:=TRUE;
                INC(index);
             END;
    END;
    close(f);
    CheckIO;

    DEC(index);

    assign(f,edatei2);
    reset(f);
    CheckIO;

    assign(g,adatei);
    rewrite(g);
    CheckIO;

    writeln(g,' ');
    writeln(g,'Comparing ',edatei1,' and ',edatei2,':');
    writeln(g,' ');

    WHILE NOT eof(f) DO
       BEGIN
          readln(f,eingabe);
          checkIO;
          IF eingabe[1]<>';' THEN
             BEGIN
                make_nlentry(eingabe,aktna,nlentry);
                stat:=suchen(nlentry.na.ges,nlentry.fu,nlentry.sn,oldname,flag);
                CASE stat OF
                   1: BEGIN
                        write(g,copy(nlentry.na.ges+spc,1,13));
                        flag:='(UNDER '+nlentry.na.nlc+') ... NEW NODE ('+nlentry.sn+')';
                        writeln(g,flag);
                      END;
                   3: BEGIN
                        IF flag='NN' THEN flag:='./.';
                        IF nlentry.fu='NN' THEN nlentry.fu:='./.';
                        write(g,copy(nlentry.na.ges+spc,1,13));
                        write(g,'(UNDER ',nlentry.na.nlc,') ... ');
                        write(g,flag);
                        write(g,' TO ');
                        writeln(g,nlentry.fu,' ('+nlentry.sn+')');
                      END;
                   4: BEGIN
                        write(g,copy(nlentry.na.ges+spc,1,13));
                        flag1:='(UNDER '+nlentry.na.nlc+') ... CHANGED ';
                        flag:=flag1+'FROM: '+oldname;
                        writeln(g,flag);
                        write(g,copy(spc,1,13+length(flag1)));
                        flag:='  TO: '+nlentry.sn;
                        writeln(g,flag);
                      END;
                END;
             END;
    END;
    close(f);
    CheckIO;

    FOR t:=1 TO index DO
       IF nfous[t] THEN
          BEGIN
             write(g,copy(nadds[t]+spc,1,13));
             flag:='(UNDER '+nnlcs[t]+') ... LOST NODE ('+nsnam[t]+')';
             writeln(g,flag);
             CheckIO;
          END;

    writeln(g,' ');
    writeln(g,'prod. by NETDIFF V1.1');

    close(g);
    CheckIO;

END. (* PROGRAM NETDIFF *)
